Index: LMDZ6/trunk/libf/dyn3d/dynetat0.f90
===================================================================
--- LMDZ6/trunk/libf/dyn3d/dynetat0.f90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d/dynetat0.f90	(revision 4046)
@@ -10,4 +10,5 @@
                          NF90_CLOSE, NF90_GET_VAR
   USE control_mod, ONLY: planet_type
+  USE strings_mod, ONLY: maxlen
   USE assert_eq_m, ONLY: assert_eq
   USE comvert_mod, ONLY: pa,preff
@@ -36,5 +37,5 @@
 !===============================================================================
 ! Local variables:
-  CHARACTER(LEN=256) :: msg, var, modname
+  CHARACTER(LEN=maxlen) :: msg, var, modname
   INTEGER, PARAMETER :: length=100
   INTEGER :: iq, fID, vID, idecal!, iml, jml, lml, nqt
@@ -126,5 +127,5 @@
 !--- Tracers
   DO iq=1,nqtot
-    var=tname(iq)
+    var=TRIM(tracers(iq)%name)
     IF(NF90_INQ_VARID(fID,var,vID)==NF90_NoErr) THEN
       CALL err(NF90_GET_VAR(fID,vID,q(:,:,:,iq)),"get",var); CYCLE
@@ -153,5 +154,5 @@
   INTEGER,          INTENT(IN) :: n1, n2
   CHARACTER(LEN=*), INTENT(IN) :: str1, str2
-  CHARACTER(LEN=100) :: s1, s2
+  CHARACTER(LEN=maxlen) :: s1, s2
   IF(n1/=n2) THEN
     s1='value of '//TRIM(str1)//' ='
Index: LMDZ6/trunk/libf/dyn3d/dynredem.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3d/dynredem.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d/dynredem.F90	(revision 4046)
@@ -12,4 +12,5 @@
                     NF90_64BIT_OFFSET
   USE dynredem_mod, ONLY: cre_var, put_var1, put_var2, err, modname, fil
+  USE strings_mod, ONLY: maxlen
   USE comvert_mod, ONLY: ap,bp,aps,bps,presnivs,pseudoalt,pa,preff, &
                               nivsig,nivsigs
@@ -38,5 +39,5 @@
   REAL    :: tab_cntrl(length)                     !--- RUN PARAMETERS TABLE
 !   For NetCDF:
-  CHARACTER(LEN=30) :: unites
+  CHARACTER(LEN=maxlen) :: unites
   INTEGER :: indexID
   INTEGER :: rlonuID, rlonvID, rlatuID, rlatvID
@@ -145,5 +146,5 @@
   CALL cre_var(nid,"teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
   DO iq=1,nqtot
-    CALL cre_var(nid,tname(iq),ttext(iq),[rlonvID,rlatuID,sID,timID])
+    CALL cre_var(nid,tracers(iq)%name,tracers(iq)%longName,[rlonvID,rlatuID,sID,timID])
   END DO
   CALL cre_var(nid,"masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
@@ -196,5 +197,5 @@
   INTEGER, PARAMETER :: length=100
   REAL               :: tab_cntrl(length) ! tableau des parametres du run
-  CHARACTER(LEN=256) :: var, dum
+  CHARACTER(LEN=maxlen) :: var, dum
   LOGICAL            :: lread_inca
 !===============================================================================
@@ -231,5 +232,5 @@
 
 !--- Save tracers
-  DO iq=1,nqtot; var=tname(iq); ierr=-1
+  DO iq=1,nqtot; var=TRIM(tracers(iq)%name); ierr=-1
     IF(lread_inca) THEN                  !--- Possibly read from "start_trac.nc"
       fil="start_trac.nc"
Index: LMDZ6/trunk/libf/dyn3d_common/infotrac.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d_common/infotrac.F90	(revision 4046)
@@ -2,4 +2,6 @@
 !
 MODULE infotrac
+
+  USE readTracFiles_mod, ONLY: trac_type, isot_type, maxlen, ancestor, delPhase
 
 ! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
@@ -26,8 +28,7 @@
   INTEGER, SAVE :: nqCO2
 
-! Name variables
-  INTEGER,PARAMETER :: tname_lenmax=128 
-  CHARACTER(len=tname_lenmax), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
-  CHARACTER(len=tname_lenmax+3), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
+! DC: derived types containing informations about tracers and isotopes
+  TYPE(trac_type), TARGET,  SAVE, ALLOCATABLE ::  tracers(:)    !=== TRACERS DESCRIPTORS VECTOR
+  TYPE(isot_type), TARGET,  SAVE, ALLOCATABLE :: isotopes(:)    !=== ISOTOPES PARAMETERS VECTOR
 
 ! iadv  : index of trasport schema for each tracer
@@ -119,10 +120,10 @@
     CHARACTER(len=8), ALLOCATABLE, DIMENSION(:) :: solsym_inca
 
-    CHARACTER(len=tname_lenmax), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
-    CHARACTER(len=tname_lenmax), ALLOCATABLE, DIMENSION(:) :: tnom_transp ! transporting fluid short name: CRisi
+    CHARACTER(len=maxlen), ALLOCATABLE, DIMENSION(:) :: tnom_0  ! tracer short name
+    CHARACTER(len=maxlen), ALLOCATABLE, DIMENSION(:) :: tnom_transp ! transporting fluid short name: CRisi
     CHARACTER(len=3), DIMENSION(30) :: descrq
     CHARACTER(len=1), DIMENSION(3)  :: txts
     CHARACTER(len=2), DIMENSION(9)  :: txtp
-    CHARACTER(len=tname_lenmax)               :: str1,str2
+    CHARACTER(len=maxlen)           :: str1,str2
   
     INTEGER :: nqtrue  ! number of tracers read from tracer.def, without higer order of moment
@@ -131,5 +132,5 @@
     LOGICAL :: continu,nouveau_traceurdef
     INTEGER :: IOstatus ! gestion de la retrocompatibilite de traceur.def
-    CHARACTER(len=2*tname_lenmax+1) :: tchaine    
+    CHARACTER(len=maxlen) :: tchaine    
 
     character(len=*),parameter :: modname="infotrac_init"
@@ -349,6 +350,6 @@
              if (nouveau_traceurdef) then
                 write(lunout,*) 'C''est la nouvelle version de traceur.def'
-                tnom_0(iq)=tchaine(1:iiq-1)
-                tnom_transp(iq)=tchaine(iiq+1:)
+                tnom_0(iq)=TRIM(tchaine(1:iiq-1))
+                tnom_transp(iq)=TRIM(tchaine(iiq+1:))
              else
                 write(lunout,*) 'C''est l''ancienne version de traceur.def'
@@ -563,5 +564,5 @@
 ! Allocate variables with total number of tracers, nqtot
 !
-    ALLOCATE(tname(nqtot), ttext(nqtot))
+    ALLOCATE(tracers(nqtot))
     ALLOCATE(iadv(nqtot), niadv(nqtot))
 
@@ -587,19 +588,19 @@
       
        str1=tnom_0(iq)
-       tname(new_iq)= tnom_0(iq)
+       tracers(new_iq)%name=TRIM(tnom_0(iq))
        IF (iadv(new_iq)==0) THEN
-          ttext(new_iq)=trim(str1)
+          tracers(new_iq)%longName=trim(str1)
        ELSE
-          ttext(new_iq)=trim(tnom_0(iq))//descrq(iadv(new_iq))
+          tracers(new_iq)%longName=trim(tnom_0(iq))//descrq(iadv(new_iq))
        ENDIF
 
        ! schemas tenant compte des moments d'ordre superieur
-       str2=ttext(new_iq)
+       str2=TRIM(tracers(new_iq)%longName)
        IF (iadv(new_iq)==20) THEN
           DO jq=1,3
              new_iq=new_iq+1
              iadv(new_iq)=-20
-             ttext(new_iq)=trim(str2)//txts(jq)
-             tname(new_iq)=trim(str1)//txts(jq)
+             tracers(new_iq)%longName=trim(str2)//txts(jq)
+             tracers(new_iq)%name=trim(str1)//txts(jq)
           END DO
        ELSE IF (iadv(new_iq)==30) THEN
@@ -607,6 +608,6 @@
              new_iq=new_iq+1
              iadv(new_iq)=-30
-             ttext(new_iq)=trim(str2)//txtp(jq)
-             tname(new_iq)=trim(str1)//txtp(jq)
+             tracers(new_iq)%longName=trim(str2)//txtp(jq)
+             tracers(new_iq)%name=trim(str1)//txtp(jq)
           END DO
        ENDIF
@@ -628,8 +629,8 @@
 
     WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
-    WRITE(lunout,*) trim(modname),': iadv  niadv tname  ttext :'
+    WRITE(lunout,*) trim(modname),': iadv  niadv  name  long_name :'
 
     DO iq=1,nqtot
-       WRITE(lunout,*) iadv(iq),niadv(iq), ' ',trim(tname(iq)),' ',trim(ttext(iq))
+       WRITE(lunout,*) iadv(iq),niadv(iq), ' ',trim(tracers(iq)%name),' ',trim(tracers(iq)%longName)
     END DO
 
@@ -802,5 +803,5 @@
     INTEGER, ALLOCATABLE,DIMENSION(:) :: nb_isoind
     INTEGER :: ntraceurs_zone_prec,iq,phase,ixt,iiso,izone
-    CHARACTER(len=tname_lenmax) :: tnom_trac
+    CHARACTER(len=maxlen) :: tnom_trac
     INCLUDE "iniprint.h"
 
Index: LMDZ6/trunk/libf/dyn3d_common/initdynav.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3d_common/initdynav.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d_common/initdynav.F90	(revision 4046)
@@ -6,5 +6,5 @@
   USE IOIPSL
 #endif
-  USE infotrac, ONLY : nqtot, ttext
+  USE infotrac, ONLY : nqtot
   use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid, &
        dynhistave_file,dynhistvave_file,dynhistuave_file
@@ -158,5 +158,6 @@
 
   !        DO iq=1,nqtot
-  !          call histdef(histaveid, ttext(iq), ttext(iq), '-', &
+  !          call histdef(histaveid, tracers(iq)%name, &
+  !                                  tracers(iq)%longName, '-',  &
   !                  iip1, jjp1, thoriid, llm, 1, llm, zvertiid, &
   !                  32, 'ave(X)', t_ops, t_wrt)
Index: LMDZ6/trunk/libf/dyn3d_common/inithist.F
===================================================================
--- LMDZ6/trunk/libf/dyn3d_common/inithist.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d_common/inithist.F	(revision 4046)
@@ -7,5 +7,5 @@
        USE IOIPSL
 #endif
-       USE infotrac, ONLY : nqtot, ttext
+       USE infotrac, ONLY : nqtot
        use com_io_dyn_mod, only : histid,histvid,histuid,               &
      &                        dynhist_file,dynhistv_file,dynhistu_file
@@ -157,5 +157,6 @@
 !
 !        DO iq=1,nqtot
-!          call histdef(histid, ttext(iq),  ttext(iq), '-',
+!          call histdef(histid, tracers(iq)%name, 
+!                               tracers(iq)%longName, '-',
 !     .             iip1, jjp1, thoriid, llm, 1, llm, zvertiid,
 !     .             32, 'inst(X)', t_ops, t_wrt)
Index: LMDZ6/trunk/libf/dyn3d_common/writedynav.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3d_common/writedynav.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d_common/writedynav.F90	(revision 4046)
@@ -6,5 +6,5 @@
   USE ioipsl
 #endif
-  USE infotrac, ONLY : nqtot, ttext
+  USE infotrac, ONLY : nqtot
   use com_io_dyn_mod, only : histaveid, histvaveid, histuaveid
   USE comconst_mod, ONLY: cpp
@@ -106,6 +106,6 @@
 
   !  DO iq=1, nqtot
-  !       call histwrite(histaveid, ttext(iq), itau_w, q(:, :, iq), &
-  !                   iip1*jjp1*llm, ndexu)
+  !       call histwrite(histaveid, tracers(iq)%longName, itau_w, &
+  !                   q(:, :, iq), iip1*jjp1*llm, ndexu)
   ! enddo
 
Index: LMDZ6/trunk/libf/dyn3d_common/writehist.F
===================================================================
--- LMDZ6/trunk/libf/dyn3d_common/writehist.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3d_common/writehist.F	(revision 4046)
@@ -7,5 +7,5 @@
       USE ioipsl
 #endif
-      USE infotrac, ONLY : nqtot, ttext
+      USE infotrac, ONLY : nqtot
       use com_io_dyn_mod, only : histid,histvid,histuid
       USE temps_mod, ONLY: itau_dyn
@@ -100,6 +100,6 @@
 C
 !        DO iq=1,nqtot
-!          call histwrite(histid, ttext(iq), itau_w, q(:,:,iq), 
-!     .                   iip1*jjp1*llm, ndexu)
+!          call histwrite(histid, tracers(iq)%longName, itau_w, 
+!     .                   q(:,:,iq), iip1*jjp1*llm, ndexu)
 !        enddo
 !C
Index: LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/dynetat0_loc.F90	(revision 4046)
@@ -11,4 +11,5 @@
       NF90_NOWRITE, NF90_CLOSE, NF90_INQUIRE_VARIABLE,  NF90_GET_VAR, NF90_NoErr
   USE control_mod, ONLY: planet_type
+  USE strings_mod, ONLY: maxlen
   USE assert_eq_m, ONLY: assert_eq
   USE comvert_mod, ONLY: pa,preff
@@ -39,5 +40,5 @@
 !===============================================================================
 ! Local variables:
-  CHARACTER(LEN=256) :: msg, var, modname
+  CHARACTER(LEN=maxlen) :: msg, var, modname
   INTEGER, PARAMETER :: length=100
   INTEGER :: iq, fID, vID, idecal, ierr
@@ -152,5 +153,5 @@
   ALLOCATE(q_glo(ip1jmp1,llm))
   DO iq=1,nqtot
-    var=tname(iq)
+    var=TRIM(tracers(iq)%name)
 #ifdef INCA
     IF (var .eq. "O3" ) THEN 
@@ -191,5 +192,5 @@
   INTEGER,          INTENT(IN) :: n1, n2
   CHARACTER(LEN=*), INTENT(IN) :: str1, str2
-  CHARACTER(LEN=256) :: s1, s2
+  CHARACTER(LEN=maxlen) :: s1, s2
   IF(n1/=n2) THEN
     s1='value of '//TRIM(str1)//' ='
Index: LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/dynredem_loc.F90	(revision 4046)
@@ -14,4 +14,5 @@
                     NF90_64BIT_OFFSET
   USE dynredem_mod, ONLY: cre_var, put_var, err, modname, fil
+  USE strings_mod, ONLY: maxlen
   USE comvert_mod, ONLY: ap,bp,aps,bps,presnivs,pseudoalt,pa,preff, &
                          nivsig,nivsigs
@@ -41,5 +42,5 @@
   REAL    :: phis_glo(ip1jmp1)
 !   For NetCDF:
-  CHARACTER(LEN=30) :: unites
+  CHARACTER(LEN=maxlen) :: unites
   INTEGER :: indexID
   INTEGER :: rlonuID, rlonvID, rlatuID, rlatvID
@@ -151,5 +152,5 @@
   CALL cre_var(nid,"teta" ,"Temperature",[rlonvID,rlatuID,sID,timID])
   DO iq=1,nqtot
-    CALL cre_var(nid,tname(iq),ttext(iq),[rlonvID,rlatuID,sID,timID])
+    CALL cre_var(nid,tracers(iq)%name,tracers(iq)%longName,[rlonvID,rlatuID,sID,timID])
   END DO
   CALL cre_var(nid,"masse","Masse d air"    ,[rlonvID,rlatuID,sID,timID])
@@ -204,5 +205,5 @@
   INTEGER, PARAMETER :: length=100
   REAL               :: tab_cntrl(length) ! tableau des parametres du run
-  CHARACTER(LEN=256) :: var, dum
+  CHARACTER(LEN=maxlen) :: var, dum
   LOGICAL            :: lread_inca
 !===============================================================================
@@ -248,5 +249,5 @@
 
 !--- Save tracers
-  DO iq=1,nqtot; var=tname(iq); ierr=-1
+  DO iq=1,nqtot; var=TRIM(tracers(iq)%name); ierr=-1
     IF(lread_inca) THEN                  !--- Possibly read from "start_trac.nc"
 !$OMP MASTER      
Index: LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/initdynav_loc.F	(revision 4046)
@@ -252,5 +252,6 @@
 C
 !        DO iq=1,nqtot
-!          call histdef(histaveid, ttext(iq), ttext(iq), '-',
+!          call histdef(histaveid, tracers(iq)%name,
+!     .                            tracers(iq)%longName, '-',
 !     .             iip1, jjn, thoriid, llm, 1, llm, zvertiid,
 !     .             32, 'ave(X)', t_ops, t_wrt)
Index: LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/inithist_loc.F	(revision 4046)
@@ -253,5 +253,6 @@
 C
 !        DO iq=1,nqtot
-!          call histdef(histid, ttext(iq), ttext(iq), '-',
+!          call histdef(histid, tracers(iq)%name, 
+!     .             tracers(iq)%longName, '-', 
 !     .             iip1, jjn, thoriid, llm, 1, llm, zvertiid,
 !     .             32, 'inst(X)', t_ops, t_wrt)
Index: LMDZ6/trunk/libf/dyn3dmem/writedynav_loc.F
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/writedynav_loc.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/writedynav_loc.F	(revision 4046)
@@ -11,5 +11,5 @@
       USE parallel_lmdz
       USE misc_mod
-      USE infotrac, ONLY : nqtot, ttext
+      USE infotrac, ONLY : nqtot
       use com_io_dyn_mod, only : histaveid,histvaveid,histuaveid
       USE comconst_mod, ONLY: cpp
@@ -177,6 +177,6 @@
 !!$OMP MASTER      
 !        DO iq=1,nqtot
-!          call histwrite(histaveid, ttext(iq), itau_w, q(ijb:ije,:,iq), 
-!     .                   iip1*jjn*llm, ndexu)
+!          call histwrite(histaveid, tracers(iq)%longName, itau_w, &
+!     .                   q(ijb:ije,:,iq), iip1*jjn*llm, ndexu)
 !        enddo
 !!$OMP END MASTER
Index: LMDZ6/trunk/libf/dyn3dmem/writehist_loc.F
===================================================================
--- LMDZ6/trunk/libf/dyn3dmem/writehist_loc.F	(revision 4045)
+++ LMDZ6/trunk/libf/dyn3dmem/writehist_loc.F	(revision 4046)
@@ -11,5 +11,5 @@
       USE parallel_lmdz
       USE misc_mod
-      USE infotrac, ONLY : nqtot, ttext
+      USE infotrac, ONLY : nqtot
       use com_io_dyn_mod, only : histid,histvid,histuid
       USE comconst_mod, ONLY: cpp
@@ -177,6 +177,6 @@
 !!$OMP MASTER      
 !        DO iq=1,nqtot
-!          call histwrite(histid, ttext(iq), itau_w, q(ijb:ije,:,iq), 
-!     .                   iip1*jjn*llm, ndexu)
+!          call histwrite(histid, tracers(iq)%longName, itau_w, 
+!     .                   q(ijb:ije,:,iq), iip1*jjn*llm, ndexu)
 !        enddo
 !!$OMP END MASTER
Index: LMDZ6/trunk/libf/dynphy_lonlat/calfis.F
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4045)
+++ LMDZ6/trunk/libf/dynphy_lonlat/calfis.F	(revision 4046)
@@ -29,5 +29,5 @@
 c    Auteur :  P. Le Van, F. Hourdin 
 c   .........
-      USE infotrac, ONLY: nqtot, niadv, tname
+      USE infotrac, ONLY: nqtot, niadv, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -481,5 +481,5 @@
          lafin_split=lafin.and.isplit==nsplit_phys
 
-        CALL call_physiq(ngridmx,llm,nqtot,tname,
+        CALL call_physiq(ngridmx,llm,nqtot,tracers(:)%name,
      &                   debut_split,lafin_split,
      &                   jD_cur,jH_cur_split,zdt_split,
@@ -522,5 +522,5 @@
 !     .             llm,            !! nlayer
 !     .             nqtot,          !! nq
-!     .             tname,          !! tracer names from dynamical core (given in infotrac)
+!     .             tracers(:)%name,!! tracer names from dynamical core (given in infotrac)
 !     .             debut_split,    !! firstcall 
 !     .             lafin_split,    !! lastcall
Index: LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4045)
+++ LMDZ6/trunk/libf/dynphy_lonlat/calfis_loc.F	(revision 4046)
@@ -45,5 +45,5 @@
       USE Times
 #endif
-      USE infotrac, ONLY: nqtot, niadv, tname
+      USE infotrac, ONLY: nqtot, niadv, tracers
       USE control_mod, ONLY: planet_type, nsplit_phys
 #ifdef CPP_PHYS
@@ -731,5 +731,5 @@
          lafin_split=lafin.and.isplit==nsplit_phys
 
-        CALL call_physiq(klon,llm,nqtot,tname,
+        CALL call_physiq(klon,llm,nqtot,tracers(:)%name,
      &                   debut_split,lafin_split,
      &                   jD_cur,jH_cur_split,zdt_split,
Index: LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 4046)
@@ -39,4 +39,5 @@
   USE comvert_mod, ONLY: ap, bp, preff, pressure_exner
   USE temps_mod, ONLY: annee_ref, day_ref, itau_dyn, itau_phy, start_time
+  USE strings_mod, ONLY: strLower
   
   IMPLICIT NONE
@@ -74,5 +75,5 @@
   USE exner_hyb_m,    ONLY: exner_hyb
   USE exner_milieu_m, ONLY: exner_milieu
-  USE infotrac,       ONLY: nqtot, tname
+  USE infotrac,       ONLY: nqtot, tracers
   USE filtreg_mod
   IMPLICIT NONE
@@ -84,5 +85,5 @@
 ! Local variables:
   CHARACTER(LEN=256) :: modname, fmt
-  INTEGER            :: i, j, l, ji, itau, iday
+  INTEGER            :: i, j, l, ji, itau, iday, iq
   REAL               :: xpn, xps, time, phystep
   REAL, DIMENSION(iip1,jjp1)       :: psol
@@ -145,5 +146,5 @@
 ! Look for ozone tracer:
 #ifndef INCA
-  DO i=1,nqtot; IF(ANY(["O3","o3"]==tname(i))) EXIT; END DO
+  DO iq=1,nqtot; IF(strLower(tracers(iq)%name)=="o3") EXIT; END DO
   IF(i/=nqtot+1) THEN
     CALL regr_lat_time_coefoz
Index: LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 4046)
@@ -16,5 +16,5 @@
   USE mod_phys_lmdz_para, ONLY: klon_omp ! number of columns (on local omp grid)
   USE vertical_layers_mod, ONLY : init_vertical_layers
-  USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tname,ttext,type_trac,&
+  USE infotrac, ONLY: nqtot,nqo,nbtr,nqCO2,tracers,type_trac,&
                       niadv,conv_flg,pbl_flg,solsym,&
                       nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
@@ -146,5 +146,5 @@
 
   ! Initialize tracer names, numbers, etc. for physics
-  CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tname,ttext,type_trac,&
+  CALL init_infotrac_phy(nqtot,nqo,nbtr,nqtottr,nqCO2,tracers,type_trac,&
                          niadv,conv_flg,pbl_flg,solsym,&
                          nqfils,nqdesc,nqdesc_tot,iqfils,iqpere,&
@@ -203,9 +203,9 @@
           rlonudyn,rlatudyn,rlonvdyn,rlatvdyn)
 #endif
-    IF (type_trac == 'repr') THEN
-#ifdef REPROBUS
-       CALL Init_chem_rep_phys(klon_omp,nbp_lev)
-#endif
-    END IF
+  END IF
+  IF (type_trac == 'repr') THEN
+#ifdef REPROBUS
+     CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+#endif
   END IF
 
